.arch armv4t @ target the ARMv4T architecture (on which the GBA's ARM7TDMI processor is based)

.section .iwram, "ax", %progbits @ use fast 32k RAM for ARM code
.align 2

.global bougeRect
bougeRect:
	stmfd	sp!, {r1-r12, lr}	@ Parametres de r0 à r4, seule la valeur sur l'axe x est changée (ou pas).
	mov	r12, #0x4000000
	mov	r11, #0x0000130
	orr	r10, r11, r12
	ldrb	r5, [r10]
	bl	fillRect	@ On dessine d'abord le rectangle pour qu'il apparaisse avant qu'on appuye sur une touche
	cmp	r5, #239	@ Si la touche à droite est appuyée on va vérifier que le paddle n'est pas au bout de l'écran, puis on le dessine
	mov	r6, r4
	beq	.L2				
	cmp	r5, #223	@ Si la touche à gauche est appuyée on va vérifier que le paddle n'est pas au bout de l'écran, puis on le dessine
	beq	.L3
	b	.L4
.L2:
	cmp	r0, #217
	movne	r4, #0
	blne	fillRect
	cmp	r0, #217
	addne	r0, r0, #1
	movne	r4, r6
	blne	fillRect
	b	.L4
.L3:
	cmp	r0, #3	
	movne	r4, #0
	blne	fillRect
	cmp	r0, #3	
	subne	r0, r0, #1
	movne	r4, r6		
	blne	fillRect
	b	.L4
.L4:
	ldmfd	sp!, {r1-r12, pc}


