.arch armv4t @ target the ARMv4T architecture (on which the GBA's ARM7TDMI processor is based)

.section .iwram, "ax", %progbits @ use fast 32k RAM for ARM code
.align 2

.global drawPixel
drawPixel:
@Fonction dessinant UN pixel sur l'ecran
@param : r0 = x, r1 = y, r2 = couleur

	stmfd	sp!,{r3-r12}			@on store tous les registres sauf params
	mov	r3, #480			@on stocke la largeur de l'ecran dans r3
	mul 	r4, r3, r1			@r3 = 480*y
	add 	r3, r4, r0, lsl #1		@r2 = r3 + x << 1
	add 	r3, r3, #0x6000000		@on ajoute l'addresse du buffer video
	strh 	r2, [r3]			@on stocke la couleur sur un demi mot
	ldmfd	sp!,{r3-r12}			@on recharge les registres de la pile
	mov	pc, lr				@on retourne au branch initial

