
.global fillRect
fillRect:
	stmfd	sp!, {r0 - r10, lr}	@ Charge dans la pile les registres de r3 à r9 et le registre r14(le load register)
	mov	r5, r0		@ On stocke x dans le registre r5
	add	r7, r0, r2	@ On stocke le résultat  de x+width dans le registre r7
	mov	r6, r1		@ On stocke y dans le registre r6
	add	r8, r1, r3	@ On stocke y+height dans r8
	mov	r9, r4		@ On stocke la couleur dans r9
.L1:	@ Boucle qui itère sur x (de .L3 à .L2)
	mov	r10, r6		@ On a maintenant y initial dans le registre r10...
.L2:	@ Boucle qui itère sur le y
	mov	r1, r10		@ ... Et l'actuel dans le registre r1
	mov	r2, r9		@ r2 vaut la couleur
	add	r10, r10, #1	@ y++
	bl	drawPixel	@ On appelle drawPixel avec r0, r1, r2 (donc x, y, c à leur valeur actuelle).
	cmp	r8, r10		@ On compare y+heigth avec y(valeur actuelle).
	bhi	.L2		@ Si y+heigth > y(actuel), recommence cette boucle.
.L3:
	add	r5, r5, #1	@ x++
	cmp	r5, r7		@ On compare x à x+width
	mov	r0, r5		@ r0 := x
	bcc	.L1		@ Si x(actuel)<x(initial)+width, on recommence à boucler sur y avec la valeur de x incrémentée
.L4:
	ldmfd	sp!, {r0 - r10, pc}	@ Rend au processeur les registres utilisés pour travailler.
