.arch armv4t @ target the ARMv4T architecture (on which the GBA's ARM7TDMI processor is based)

.section .iwram, "ax", %progbits @ use fast 32k RAM for ARM code
.align 2

.L5:
	add	r7, r6, #20	@ Position du bout à droite du Paddle
.L7:
	cmp	r0, r7		@ Si on est sur le Paddle, on rebondit;
	rsbeq	r5, r5, #0
	beq	.L6
	subne	r7, r7, #1	@ Sinon on continue de tester les autres positions
	cmp	r7, r6
	bgt	.L7
	beq	.L6

.global bougeCircle
bougeCircle:
	stmfd	sp!, {r8-r12, lr}
	mov	r12, r3
	sub	r3, r12, r12
	bl	drawCircle	@ dessine en noir par dessus le cercle precedent
	mov	r3, r12
	add	r0, r0, r4
	add	r1, r1, r5
	cmp	r0, #5
	rsbeq	r4, r4, #0
	cmp	r0, #234
	rsbeq	r4, r4, #0
	cmp	r1, #5
	rsbeq	r5, r5, #0
	cmp	r1, #154
	beq	.L5
	bl	drawCircle	@ dessine le cercle blanc deplacé
	@ Boucle dégueulasse permettant de rallentir la balle (rajouter des boucles 
.L6:
	mov	r7, #31		
	mov	r8, #31
	lsl	r9, r8, #5
	add	r7, r7, r5
	lsl	r9, r8, #10
	add	r7, r7, r9
	mov	r10, r7
	mov	r11, r7
.L2:
	cmp	r10, #0
	subgt	r10, r10, #1
	bgt	.L2
	@ Fin du massacre
	cmp	r1, #160
	moveq	r7, #1	@ On met 1 dans r7 si on a perdu
	movne	r7, #0	@ Sinon il y a la valeur 0 dedans.
	ldmfd	sp!, {r8-r12, pc}
