.arch armv4t @ target the ARMv4T architecture (on which the GBA's ARM7TDMI processor is based)

.section .iwram, "ax", %progbits @ use fast 32k RAM for ARM code
.align 2

.global drawCircle
drawCircle:
	stmfd	sp!, {r0-r10, fp, lr}
	mov	r9, r0
	mov	r10, r1
	mov	r4, r2	@ r4 contient le rayon (=x)
	mov	r5, #0	@ r5 contient la valeur 0 (=y)
	mov	r2, r3
	rsb	r6, r4, #1	@ L'erreur stockée en r6, vaut 1-x
.L1:
	add	r0, r4, r9
	add	r1, r5, r10
	bl	drawPixel
	add	r0, r5, r9
	add	r1, r4, r10
	bl	drawPixel
	sub	r0, r9, r4
	add	r1, r5, r10
	bl	drawPixel
	sub	r0, r9, r5
	add	r1, r4, r10
	bl	drawPixel
	sub	r0, r9, r4
	sub	r1, r10, r5
	bl	drawPixel
	sub	r0, r9, r5
	sub	r1, r10, r4
	bl	drawPixel
	add	r0, r9, r4
	sub	r1, r10, r5
	bl	drawPixel
	add	r0, r5, r9
	sub	r1, r10, r4
	bl	drawPixel
	add	r5, r5, #1
	cmp	r6, #0
	bmi	.L2
	sub	r4, r4, #1
	add	r6, r6, r5
	add	r6, r6, r5
	sub	r6, r6, r4
	sub	r6, r6, r4
	add	r6, r6, #1
.L3:
	cmp	r4, r5	@ Z=1 si x=y, N=1 si r4<r5
	bpl	.L1
	b	.L4
.L2:	add	r6, r6, r5
	add	r6, r6, r5
	add	r6, r6, #1
	b	.L3
.L4:

	ldmfd	sp!, {r0-r10, fp, pc}	@ Rend au processeur les registres utilisés pour travailler.
