.arch armv4t @ target the ARMv4T architecture (on which the GBA's ARM7TDMI processor is based)

.section .iwram, "ax", %progbits @ use fast 32k RAM for ARM code
.align 2

.global drawLine
drawLine:
	stmfd	sp!, {r0-r12, lr}
	mov	r5, r0		@ r5 contient x, soit xi au début
	mov	r6, r1		@ r6 contient y, soit yi
	sub	r7, r2, r0	@ r7 contient dx, soit xf-xi
	cmp	r7, #0		@ comparons si dx est positif....
	mov	r9, #1		@ On met en r9, xinc, la valeur de 1
	rsble	r9, r9, #0	@ On la change en -1 si dx était négatif
	rsblt	r7, r7, #0	@ Et on met en r7 sa valeur absolue
	sub	r8, r3, r1	@ Même travail pour r8 (dy) et r10 (yinc)
	cmp	r8, #0		
	mov	r10, #1
	rsble	r10, r10, #0
	rsblt	r8, r8, #0
	mov	r2, r4
	mov	r0, r5		@ On met les paramètres dans les bons registres pour pouvoir appeler drawPixel avec
	mov	r1, r6
	bl	drawPixel
	cmp	r7, r8
	lsrgt	r11, r7, #1
	mov	r3, #1
	bgt	.L2
	lsrle	r11, r8, #1
	ble	.L3
.L2:
	add	r0, r0, r9
	add	r11, r11, r8
	cmp	r11, r7
	subge	r11, r11, r7
	addge	r1, r1, r10
	bl	drawPixel
	add	r3, r3, #1
	cmp	r3, r7
	bgt	.L4
	b	.L2
.L3:
	add	r1, r1, r10
	add	r11, r11, r7
	cmp	r11, r8
	subge	r11, r11, r8
	addge	r0, r0, r9
	bl	drawPixel
	add	r3, r3, #1
	cmp	r3, r8
	bgt	.L4
	b	.L3
.L4:
	ldmfd	sp!, {r0-r12, pc}
	
	
