.arch armv4t @ target the ARMv4T architecture (on which the GBA's ARM7TDMI processor is based)

.section .iwram

.global	main
main:
	mov	r12, #1024			@r12 = BG2_ENABLE
	add	r12, r12, #3			@ choix du mode 3
	mov	r11, #67108864			@r11 = REG_DISPCNT.arch armv4t @ target the ARMv4T architecture (on which the GBA's ARM7TDMI processor is based)
	str	r12, [r11,#0]
	
	@ Debut du jeu
	bl	drawCadre	@ On dessine les lignes du cadre
	
	@ INITIALISATION DU CERCLE
	mov	r0, #120		@ Position x du centre du cercle
	mov	r1, #20		@ Position y du centre du cercle
	mov	r2, #2		@ Rayon du cercle	
	mov	r3, #31		@ Couleur blanche du cercle
	add	r3, r3, lsl #5
	add	r3, r3, lsl #10
	mov	r4, #1		@ Vecteur directeur en x du cercle
	mov	r5, #1		@ Vecteur directeur en y du cercle
	@ On stocke toutes ces valeurs dans la pile
	str	r0, [sp]
	str	r1, [sp, #4]
	str	r2, [sp, #8]
	str	r3, [sp, #12]
	str	r4, [sp, #16]
	str	r5, [sp, #20]
	
	@ INITIALISATION DU PADDLE
	mov	r0, #110
	mov	r1, #157
	mov	r2, #20
	mov	r3, #2
	mov	r4, #10		@ La couleur sera un melange de peu de rouge avec plus de vert et de bleu
	mov	r5, #25
	add	r4, r5, lsl #5
	add	r4, r5, lsl #10
	@ On stocke les valeurs dans la pile
	str	r0, [sp, #24]
	str	r1, [sp, #28]
	str	r2, [sp, #32]
	str	r3, [sp, #36]
	str	r4, [sp, #40]

	@ DEBUT DU MOUVEMENT
.L2:
	mov	r7, #0	@ Variable testant la fin du jeu
	ldr	r0, [sp]
	ldr	r1, [sp, #4]
	ldr	r2, [sp, #8]
	ldr	r3, [sp, #12]
	ldr	r4, [sp, #16]
	ldr	r5, [sp, #20]
	ldr	r6, [sp, #24]
	bl	bougeCircle
	str	r0, [sp]
	str	r1, [sp, #4]
	str	r2, [sp, #8]
	str	r3, [sp, #12]
	str	r4, [sp, #16]
	str	r5, [sp, #20]
	str	r6, [sp, #24]
	cmp	r7, #1
	beq	.Fin
	ldr	r0, [sp, #24]
	ldr	r1, [sp, #28]
	ldr	r2, [sp, #32]
	ldr	r3, [sp, #36]
	ldr	r4, [sp, #40]
	bl	bougeRect
	str	r0, [sp, #24]
	str	r1, [sp, #28]
	str	r2, [sp, #32]
	str	r3, [sp, #36]
	str	r4, [sp, #40]
	b	.L2
	mov	pc, lr
.Fin:
	@ Checke si boutton appuye
	mov	r12, #0x4000000
	mov	r11, #0x0000130
	orr	r10, r11, r12
	ldrb	r5, [r10]
	cmp	r5, #247
	bne	.Fin
	moveq	r0, #0
	moveq	r1, #0
	moveq	r2, #240
	moveq	r3, #160
	moveq	r4, #0
	bleq	fillRect
	beq	main
